// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockJobs is an autogenerated mock type for the Jobs type
type MockJobs struct {
	mock.Mock
}

// AddJobToPipelineTask provides a mock function with given fields: ctx, pipelineID, taskPath, job
func (_m *MockJobs) AddJobToPipelineTask(ctx context.Context, pipelineID string, taskPath string, job *models.Job) error {
	ret := _m.Called(ctx, pipelineID, taskPath, job)

	if len(ret) == 0 {
		panic("no return value specified for AddJobToPipelineTask")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, *models.Job) error); ok {
		r0 = rf(ctx, pipelineID, taskPath, job)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// CreateJob provides a mock function with given fields: ctx, job
func (_m *MockJobs) CreateJob(ctx context.Context, job *models.Job) (*models.Job, error) {
	ret := _m.Called(ctx, job)

	if len(ret) == 0 {
		panic("no return value specified for CreateJob")
	}

	var r0 *models.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Job) (*models.Job, error)); ok {
		return rf(ctx, job)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Job) *models.Job); ok {
		r0 = rf(ctx, job)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Job) error); ok {
		r1 = rf(ctx, job)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJobByID provides a mock function with given fields: ctx, id
func (_m *MockJobs) GetJobByID(ctx context.Context, id string) (*models.Job, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetJobByID")
	}

	var r0 *models.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Job, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Job); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJobByPRN provides a mock function with given fields: ctx, prn
func (_m *MockJobs) GetJobByPRN(ctx context.Context, prn string) (*models.Job, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetJobByPRN")
	}

	var r0 *models.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Job, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Job); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJobCountForAgent provides a mock function with given fields: ctx, agentID
func (_m *MockJobs) GetJobCountForAgent(ctx context.Context, agentID string) (int, error) {
	ret := _m.Called(ctx, agentID)

	if len(ret) == 0 {
		panic("no return value specified for GetJobCountForAgent")
	}

	var r0 int
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (int, error)); ok {
		return rf(ctx, agentID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) int); ok {
		r0 = rf(ctx, agentID)
	} else {
		r0 = ret.Get(0).(int)
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, agentID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJobs provides a mock function with given fields: ctx, input
func (_m *MockJobs) GetJobs(ctx context.Context, input *GetJobsInput) (*JobsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetJobs")
	}

	var r0 *JobsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetJobsInput) (*JobsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetJobsInput) *JobsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*JobsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetJobsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateJob provides a mock function with given fields: ctx, job
func (_m *MockJobs) UpdateJob(ctx context.Context, job *models.Job) (*models.Job, error) {
	ret := _m.Called(ctx, job)

	if len(ret) == 0 {
		panic("no return value specified for UpdateJob")
	}

	var r0 *models.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Job) (*models.Job, error)); ok {
		return rf(ctx, job)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Job) *models.Job); ok {
		r0 = rf(ctx, job)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Job) error); ok {
		r1 = rf(ctx, job)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockJobs creates a new instance of MockJobs. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockJobs(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockJobs {
	mock := &MockJobs{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
